#include "stdafx.h"
#include "msPlugInImpl.h"
#include "msLib.h"

#define VER "Ani Exporter  0.65 by hyun..."

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}



cMsPlugIn*	CreatePlugIn ()
{
    return new cPlugIn ();
}



cPlugIn::cPlugIn ()
{
    strcpy (szTitle, VER);
}



cPlugIn::~cPlugIn ()
{
}



int	cPlugIn::GetType ()
{
    return cMsPlugIn::eTypeExport;
}



const char*	cPlugIn::GetTitle ()
{
    return szTitle;
}



int	cPlugIn::Execute (msModel *pModel)
{
    if (!pModel)
        return -1;

    //
    // check, if we have something to export
    //
    if (msModel_GetMeshCount (pModel) == 0)
    {
        ::MessageBox (NULL, "The model is empty!  Nothing exported!", "RAW Export", MB_OK | MB_ICONWARNING);
        return 0;
    }
 	

    //
    // choose filename
    //
    OPENFILENAME ofn;
    memset (&ofn, 0, sizeof (OPENFILENAME));
    
    char szFile[MS_MAX_PATH];
    char szFileTitle[MS_MAX_PATH];
    char szDefExt[32] = "ani";
    char szFilter[128] = "Ani Files (*.ani)\0*.ani\0All Files (*.*)\0*.*\0\0";
    szFile[0] = '\0';
    szFileTitle[0] = '\0';

    ofn.lStructSize = sizeof (OPENFILENAME);
    ofn.lpstrDefExt = szDefExt;
    ofn.lpstrFilter = szFilter;
    ofn.lpstrFile = szFile;
    ofn.nMaxFile = MS_MAX_PATH;
    ofn.lpstrFileTitle = szFileTitle;
    ofn.nMaxFileTitle = MS_MAX_PATH;
    ofn.Flags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST;
    ofn.lpstrTitle = "Export Ani";

    if (!::GetSaveFileName (&ofn))
        return 0;

    //
    // export
    //
    FILE *file = fopen (szFile, "wt");
    if (!file)
        return -1;

    int i, j,k;
    int n,index,frame_n;
    msVec3 vec3;
    char szName[64];
    msBone *pBone;
		int joint_n;
//int           msModel_GetFrame (msModel *pModel);
//int           msModel_GetTotalFrames (msModel *pModel);
//int           msModel_FindBoneByName (msModel *pModel, const char *szName);

    pBone = msModel_GetBoneAt (pModel, 0);

    joint_n= msModel_GetBoneCount (pModel);
    frame_n=msBone_GetPositionKeyCount(pBone); // bone Ӽ 
    fprintf (file, "frame_n= %d\n",frame_n);
    fprintf (file, "joint_n= %d\n",joint_n);

    for (j = 0; j < joint_n; j++)
    {
	    msBone *pBone = msModel_GetBoneAt (pModel, j);

	    msPositionKey*  PositionKey;
	    msRotationKey*  RotationKey;

	    n=msBone_GetPositionKeyCount(pBone);
	    fprintf (file, "joint%d= %d\n",j,n);
	    fprintf (file, "{\n");
	    for (i = 0; i < frame_n; i++){
		    PositionKey=msBone_GetPositionKeyAt (pBone,i);
		    fprintf (file, "\t%d  %f %f %f   ",i, PositionKey->Position[0]
				    ,PositionKey->Position[1]
				    ,PositionKey->Position[2] );
		    RotationKey=msBone_GetRotationKeyAt(pBone,i);
		    fprintf (file, "\t%f %f %f \n",RotationKey->Rotation[0]
				    ,RotationKey->Rotation[1]
				    ,RotationKey->Rotation[2]);
	    }

	    fprintf (file, "}\n",i);
    }

    fclose (file);
  
    // dont' forget to destroy the model
    msModel_Destroy (pModel);
    
    return 0;
}

/*
//   fprintf (file, "//   %s \n",VER);
//    fprintf (file, "//   position x,y,z  rotation  x,y,z   \n");
//    msModel_SetFrame (msModel *pModel, int nFrame);
//    n=msModel_GetFrame(pModel);
//    fprintf (file, " current_frame_n=%d\n",n);


    n=msModel_GetTotalFrames (pModel);
    for (i = 0; i < n; i++)
    {
	    char szName[64];
	   

	    fprintf (file, "frame_num= %d\n",i);
	    fprintf (file, "{\n",i);
//	    msModel_SetFrame (msModel *pModel, int nFrame);

	    for (j = 0; j < joint_n; j++)
	    {
		    msBone *pBone = msModel_GetBoneAt (pModel, j);
		    msPositionKey*  PositionKey;
		    msRotationKey*  RotationKey;
		
		    PositionKey=msBone_GetPositionKeyAt (pBone,i);
		    fprintf (file, "\t%d  %f %f %f   ",j, PositionKey->Position[0]
				    ,PositionKey->Position[1],
					,PositionKey->Position[2] );
		    RotationKey=msBone_GetRotationKeyAt(pBone,i);

		    fprintf (file, "\t%f %f %f \n",RotationKey->Rotation[0]
				    ,RotationKey->Rotation[1]
				    ,RotationKey->Rotation[2]);

	    }
	    fprintf (file, "}\n",i);
    }
*/



/*	msBone_GetPosition(pBone,vec3);
		    fprintf (file, "\t%d  %f %f %f   ",j, vec3[0], vec3[1], vec3[2]);
		    msBone_GetRotation(pBone,vec3);
		    fprintf (file, "\t%f %f %f \n", vec3[0], vec3[1], vec3[2]);
*/		 
